var widgetAPI;
var pluginAPI;
var tvKey;

var STATE_MODAL = 1;
var STATE_FULLSCREEN = 2;
var STATE_NORMAL = 3;
var STATE_LOADING = 4;
var STATE_LOADED = 5;
var STATE_DISCONNECTED = 6;

var QUALITY_LOW = 3;
var QUALITY_MEDIUM = 2;
var QUALITY_HIGH = 1;

var APP_STATE = STATE_NORMAL;
var STATE_LOAD = STATE_LOADED;

var Config = {
	'app_states': {
		STATE_MODAL: false,
		STATE_FULLSCREEN: false,
		STATE_NORMAL: false,
		STATE_DISCONNECTED: false
	},
	'is_unbreakable': false,
	'server': 'http://masterkaraoke.com/api/samsung/1205/',	
	'focus': 'left_0',
	'preview': 'http://masterkaraoke.com/_/video/preview.mp4',
	'login_file': 'phone.data',
	'localization_file': 'localization.data',
	'manufacturer': 1,
	'sault': 'MKW321!',
	'paymentCount': 0,
	'paymentInterval': false,
	'paymentMaxCount': 20,
	'payment_delay': 10000,
	'block': true,
	'localization': '',
	'loaded_index': false,
	'state_before': false,
	'ajax_timeout': 20000
};
var Main = {};

Main.onLoad = function() {
	widgetAPI = new Common.API.Widget();
	tvKey = new Common.API.TVKeyValue();
	pluginAPI = new Common.API.Plugin();
	User.networkPlugin = document.getElementById('pluginNetwork');
	setInterval('User.checkNetwork();', 10000);
	
	Config.app_states[STATE_DISCONNECTED] = [tvKey.KEY_EXIT];
	
	Config.app_states[STATE_LOADING] = [tvKey.KEY_PANEL_MENU, tvKey.KEY_RETURN, tvKey.KEY_EXIT];
	
	Config.app_states[STATE_MODAL] = [tvKey.KEY_PANEL_CH_UP, tvKey.KEY_UP,
	                           tvKey.KEY_PANEL_CH_DOWN, tvKey.KEY_DOWN, 
	                           tvKey.KEY_PANEL_VOL_DOWN, tvKey.KEY_LEFT, 
	                           tvKey.KEY_PANEL_VOL_UP, tvKey.KEY_RIGHT,
	                           tvKey.KEY_PANEL_ENTER, tvKey.KEY_PANEL_SOURCE, tvKey.KEY_ENTER,
	                           tvKey.KEY_EXIT, tvKey.KEY_PANEL_MENU, tvKey.KEY_RETURN];
		
	Config.app_states[STATE_FULLSCREEN] = [tvKey.KEY_GREEN, tvKey.KEY_BLUE, tvKey.KEY_RED, tvKey.KEY_YELLOW,
	                                       tvKey.KEY_FF, tvKey.KEY_STOP, tvKey.KEY_EXIT, tvKey.KEY_PANEL_MENU,
	                                       tvKey.KEY_RETURN];
	
	Config.app_states[STATE_NORMAL] = $.merge( $.merge( [tvKey.KEY_0, tvKey.KEY_1, tvKey.KEY_2, tvKey.KEY_3, 
	                                                    tvKey.KEY_4, tvKey.KEY_5, tvKey.KEY_6, tvKey.KEY_7, 
	                                                    tvKey.KEY_8, tvKey.KEY_9], Config.app_states[STATE_MODAL]), Config.app_states[STATE_FULLSCREEN]);
		
	window.onShow = onShowEvent;
	widgetAPI.sendReadyEvent();
				
	Config.localization = FileSys.readFromFile(Config.localization_file);	
	User.init();
			
	Navigator.jsonp('loadIndex', false, false);
	
};

onShowEvent = function() {
	var nnaviPlugin = document.getElementById('pluginNnavi');
	nnaviPlugin.SetBannerState(1);
	
	//volume
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	
	//return exit
	pluginAPI.registKey(tvKey.KEY_RETURN);
	pluginAPI.registKey(tvKey.KEY_PANEL_MENU);
	pluginAPI.registKey(tvKey.KEY_EXIT);
	
	//numbers
	pluginAPI.registKey(tvKey.KEY_0);
	pluginAPI.registKey(tvKey.KEY_1);
	pluginAPI.registKey(tvKey.KEY_2);
	pluginAPI.registKey(tvKey.KEY_3);
	pluginAPI.registKey(tvKey.KEY_4);
	pluginAPI.registKey(tvKey.KEY_5);
	pluginAPI.registKey(tvKey.KEY_6);
	pluginAPI.registKey(tvKey.KEY_7);
	pluginAPI.registKey(tvKey.KEY_8);
	pluginAPI.registKey(tvKey.KEY_9);
	
	//navigation
	//up
	pluginAPI.registKey(tvKey.KEY_PANEL_CH_UP);
	pluginAPI.registKey(tvKey.KEY_UP);
	//down
	pluginAPI.registKey(tvKey.KEY_PANEL_CH_DOWN);
	pluginAPI.registKey(tvKey.KEY_DOWN);
	//left
	pluginAPI.registKey(tvKey.KEY_PANEL_VOL_DOWN);
	pluginAPI.registKey(tvKey.KEY_LEFT);
	//right
	pluginAPI.registKey(tvKey.KEY_PANEL_VOL_UP);
	pluginAPI.registKey(tvKey.KEY_RIGHT);
	//enter
	pluginAPI.registKey(tvKey.KEY_PANEL_ENTER);
	pluginAPI.registKey(tvKey.KEY_PANEL_SOURCE);
	pluginAPI.registKey(tvKey.KEY_ENTER);
	
	//color
	pluginAPI.registKey(tvKey.KEY_GREEN);
	pluginAPI.registKey(tvKey.KEY_BLUE);
	pluginAPI.registKey(tvKey.KEY_RED);
	pluginAPI.registKey(tvKey.KEY_YELLOW);
	
	//player
	pluginAPI.registKey(tvKey.KEY_STOP);
	pluginAPI.registKey(tvKey.KEY_FF);
	pluginAPI.registKey(tvKey.KEY_RW);
	pluginAPI.registKey(tvKey.KEY_PAUSE);
	pluginAPI.registKey(tvKey.KEY_PLAY);
	
	
	//other
	pluginAPI.registKey(tvKey.KEY_TOOLS);
	pluginAPI.registKey(tvKey.KEY_INFO);
	pluginAPI.registKey(tvKey.KEY_EMODE);
	pluginAPI.registKey(tvKey.KEY_DMA);
	pluginAPI.registKey(tvKey.KEY_MENU);
	pluginAPI.registKey(tvKey.KEY_SOURCE);
	pluginAPI.registKey(tvKey.KEY_PRECH);
	pluginAPI.registKey(tvKey.KEY_FAVCH);	
	pluginAPI.registKey(tvKey.KEY_CHLIST);
	pluginAPI.registKey(tvKey.KEY_TTX_MIX);
	pluginAPI.registKey(tvKey.KEY_GUIDE);
	pluginAPI.registKey(tvKey.KEY_SUBTITLE);	
	pluginAPI.registKey(tvKey.KEY_ASPECT);
	pluginAPI.registKey(tvKey.KEY_DOLBY_SRR);
	pluginAPI.registKey(tvKey.KEY_MTS);
	pluginAPI.registKey(tvKey.KEY_WHEELDOWN);
	pluginAPI.registKey(tvKey.KEY_WHEELUP);
};
