var microphone;

try {
	microphone = window.webapis.microphone;
} catch (e) {
	microphone = false;
	addLog("Microphone not supported");
	Navigator.errorHandle('Microphone not supported!', 'error');
	$('#mic').hide();
}	

var useMic = {};
var MicStatus = {};
var Mic = {};

Mic.onDeviceStatusChange = function(sParam) {
	addLog("onDeviceStatusChange");
	switch (sParam.eventType) {
		case microphone.MGR_EVENT_DEV_CONNECT:
			MicStatus[sParam.UID] = microphone.MGR_EVENT_DEV_CONNECT;
			microphone.getMicrophones(Mic.onMicrophoneObtained);
			break;
		case microphone.MGR_EVENT_DEV_DISCONNECT:
			if (useMic[sParam.UID]) {
				useMic[sParam.UID].stop();
				useMic[sParam.UID].disableDevice();
				useMic[sParam.UID] = false;
				$('#mic').attr('src', 'app/resources/no_mic_s.png');
			}
			break;
	}
};

Mic.addMicrophone = function(mic) {
	addLog("addMicrophone");
	if (mic!=null) useMic[mic.getUniqueID()] = mic;
};

Mic.playMicrophone = function(micid) {
	addLog("playMicrophone");
	if (useMic[micid]) {
		if (useMic[micid].enableDevice(microphone.MICROPHONE_FORMAT_SIGNED_16BIT_LITTLE_ENDIAN, microphone.MICROPHONE_FRAMERATE_48000) == false) {
			return false;
		}
		if (useMic[micid].play() == false) {
			return false;
		}
		$('#mic').attr('src', 'app/resources/mic_s.png');
		useMic[micid].setVolumeLevel(70);
		return true;
	}
	return false;
};

Mic.onMicrophoneObtained = function(mics) {
	addLog("onMicrophoneObtained");
	addLog('mics count: ' + mics.length);
	if (mics && mics.length > 0) {
		for (var i=0; i<mics.length; i++){
			if (mics[i]!=null) {
                useMic[mics[i].getUniqueID()] = mics[i];
                var mic_status = MicStatus[mics[i].getUniqueID()]; 
                if (mic_status) {
                	if (mic_status == microphone.MGR_EVENT_DEV_CONNECT) {
                		if (Mic.playMicrophone(mics[i].getUniqueID())) MicStatus[mics[i].getUniqueID()] = false;
                	}
                }
			}
		}
	}
};

function dump(obj, depth) {
	var out = '';
	if (depth == undefined) depth = 0;
    switch (typeof obj) {
    case 'object':
    	for (var i in obj) {
    		out += i + ": " + dump(obj[i], depth + 1) + "\n";
    	}
    	break;
    
    default:
    	out += obj + "\n";
    	break;
    
    }

    return out;

}
//addLog("starting microphone");
//microphone = window.webapis.microphone || {};
//microphone.registerManagerCallback(Mic.onDeviceStatusChange);


//addLog(dump(microphone));
//addLog("finish microphone info");
//var mm = microphone.getMicrophones(Mic.onMicrophoneObtained);
//addLog("mm.count="+mm.length);