var Navigator = {'path': {'history':[], 'current': false}};

Navigator.jsonp = function(action, params, withLoader, withoutErrorHandle) {
	if (APP_STATE == STATE_DISCONNECTED) return;
	var url = Config.server;
	Config.is_unbreakable = false;
	switch (action) {
		case 'loadIndex': { 
			url += 'samsung/catalog/loadIndex?jsoncallback=?&country='+User.params.country+'&localization='+Config.localization;
			break;
		};
		case 'loadSongAuthor': {
			var id = jQuery('#'+params[0]+'_'+params[1]).attr('param');
			if (!id) return;
			url += 'catalog/loadSongsByAuthor?jsoncallback=?&id='+id+'&country=' + User.params.country+'&localization='+Config.localization;
			break;
		};
		case 'loadReturn': {
			url = params;
			break;
		};
		case 'loadLicense': {
			url += 'user/license?jsoncallback=?&page='+params+'&country=' + User.params.country+'&localization=' + Config.localization;
			break;
		}
		case 'activeFreeSubscription': {
			url += 'user/ActiveFreeSubscription?jsoncallback=?&country='+User.params.country+'&device='+User.device+'&localization='+Config.localization;
			Config.is_unbreakable = true;
			break;
		};
		case 'finishCoupon': {
			var code = Navigator.getInputsValues('.blue_block.reg input');
			if (!code) return;
			url += 'user/FinishCoupon?jsoncallback=?&country='+User.params.country+'&device='+User.device+'&code='+code+'&localization='+Config.localization;
			break;
		};
		case 'loadCouponForm': {
			url += 'user/LoadCouponForm?jsoncallback=?&country='+User.params.country+'&device='+User.device+'&localization='+Config.localization;
			break;
		};
		case 'startCheckPayment': {
			if (params[0] == undefined || params[1] == undefined) return;
			Config.paymentCount++;
			if (Config.paymentCount > Config.paymentMaxCount) {
				jQuery('#modal h1').html('Превышен максимальный интервал ожидания. Попробуйте еще раз.');
				jQuery('#modal img').remove();
				return;
			}
			url += 'user/CheckPayment?jsoncallback=?&country='+User.params.country+'&id='+params[0]+'&login='+params[1]+'&localization='+Config.localization;
			break;
		}; 
		case 'progressSubscription': {
			if (params == undefined) return;
			var login = rc4_encode(Navigator.getInputsValues('.blue_block.reg input'));
			if (!login) return;
			url += 'user/ProgressSubscriptionForm?jsoncallback=?&country='+User.params.country+'&id='+params+'&login='+login+'&device='+User.device+'&localization='+Config.localization;
			Config.is_unbreakable = true;
			break;
		};
		case 'startSubscription': {
			if (params == undefined) return;
			var login;
			if (!User.login) {
				login = FileSys.readFromFile(Config.login_file);
			} else login = User.login;
			url += 'user/StartSubscriptionForm?jsoncallback=?&country='+User.params.country+'&id='+params+'&login='+login+'&localization='+Config.localization;
			break;
		};
		case 'loadBankCardInfo': {
			if (params == undefined) return;
			url += 'user/LoadBankCardInfo?jsoncallback=?&country='+User.params.country+'&id='+params+'&login='+User.login+'&localization='+Config.localization;
			break;
		};
		case 'loadSubscriptionVariants': {
			if (params == undefined) return;
			url += 'user/SubscriptionVariantsForm?jsoncallback=?&country='+User.params.country+'&id='+params+'&login='+User.login+'&localization='+Config.localization;
			break;
		};
		case 'loadSubscription': {
			var login = false;
			if (User.is_login) login = User.login;
			url += 'user/GetSubscriptionForm?jsoncallback=?&country='+User.params.country+'&device='+User.device+'&login='+login+'&localization='+Config.localization+'&license_confirm='+User.license_confirm;
			break;
		};
		case 'logout': {
			Config.is_unbreakable = true;
			url += 'user/Logout?jsoncallback=?&country='+User.params.country+'&login='+User.login+'&device='+User.device+'&localization='+Config.localization;
			break;
		};
		case 'startAuth': {
			if (!User.device || !params) return;
			User.login = rc4_encode(params);
			Config.is_unbreakable = true;
			url += 'user/StartAuth?jsoncallback=?&login='+User.login+'&country='+User.params.country+'&localization='+Config.localization;
			break;
		};
		case 'finishAuth': {
			if (!User.device || !params) return;
			Config.is_unbreakable = true;
			url += 'user/FinishAuth?jsoncallback=?&login='+User.login+'&country='+User.params.country+'&password='+rc4_encode(params)+'&device='+User.device+'&localization='+Config.localization;
			break;
		};
		case 'checkUser': {
			if (!User.device) return;
			url += 'user/CheckUser?jsoncallback=?&device='+User.device+'&login='+User.login+'&country='+User.params.country+'&localization='+Config.localization;
			break;
		};
		case 'isActiveDevice': {
			url += 'user/ActiveDeviceValidator?jsoncallback=?&duid='+User.duid+'&manufacturer='+Config.manufacturer+'&code='+User.params.product+'&model_id='+User.params.modelid+'&localization='+Config.localization;
			break;
		};
		case 'loadProfile': {
			if (User.is_login) {
				url += 'user/LoadProfile?jsoncallback=?&country='+User.params.country+'&login='+User.login+'&localization='+Config.localization;
			} else {
				url += 'user/LoadAuth?jsoncallback=?&country='+User.params.country+'&localization='+Config.localization;
				var login = FileSys.readFromFile(Config.login_file);
				if (login != undefined && login.length) url += '&login='+login;
			}
			url += '&country='+User.params.country+'&device='+User.device;
			break;
		}
		case 'loadHistory': {
			params = Navigator.path.history[Navigator.path.history.length-1];
			if (params == undefined || params.url == undefined) return;
			url = params.url;
			if (User.license_confirm && url.indexOf('license_confirm', 0) > 0) {
				url = url.replace('license_confirm=', '') + '&license_confirm=true';
			}			
			Navigator.path.history.pop();
			Navigator.path.current = url;
			break;
		};
		case 'loadMain': {
			var element = jQuery('#'+params[0]+'_'+params[1]);
			var loadaction = jQuery(element).attr('action');
			if (!loadaction) return;
			var id = jQuery(element).attr('param');
			var page = jQuery(element).attr('page');
			url += loadaction + '?jsoncallback=?';
			if (id !== undefined) url += '&id='+id;
			if (page !== undefined) {
				url +=  '&page='+page;
				var current = jQuery(element).attr('id');
				if (current !== undefined) {
					Navigator.setForceFocus(params[0]+'_'+params[1]);
					url += '&current='+current;
				}
			}
			if (User.params.country) url += '&country=' + User.params.country+'&localization='+Config.localization;
			break;
		};
		default: return;
	};
	addLog(url);
	if (withLoader) toggleLoadState();
	$.ajax({
		url: url,
		dataType: 'json',
		timeout: Config.ajax_timeout, 
		success: function(json){
			if (withLoader) {
				if (STATE_LOAD != STATE_LOADING) {
					addLog('ABORTED');
					return;
				}
				toggleLoadState();
			}	
			if (!withoutErrorHandle && json.error) return Navigator.errorHandle(json.error);
			addLog('OK');
			switch (action) {
				case 'loadIndex': { 
					$('#body').html(json.content);
					Navigator.getBlockElements();
					Navigator.loadMain(['left',0]);
					jQuery('.clear_playlist').hide();
					jQuery('.high_quality').hide();
					if (User.params.country == 'RU' || User.params.country == 'ru'){
						Navigator.playPreview();
					}
					Config.loaded_index = true;
					if (microphone) {	
						microphone.registerManagerCallback(Mic.onDeviceStatusChange);
						microphone.getMicrophones(Mic.onMicrophoneObtained);
					}
					break;	
				};
				case 'loadMain':
				case 'loadSongAuthor': {
					Navigator.addHistory(url, params[0]+'_'+params[1]);
					Navigator.parseConfig(json, params[0]);
					if (json.content.error) {
						Navigator.errorHandle(json.content.error, 'preview');
					}
					break;
				};
				case 'finishAuth': {
					if (json.content) {
						User.is_login = true;
						FileSys.writeToFile(Config.login_file, User.login);						
						Navigator.loadProfile();						
					} else return;	
					break;
				};
				case 'checkUser': {
					if (json.content) {
						User.is_login = true;						
					} else return;
					break;
				};
				case 'logout': {
					User.is_login = false;
					User.login = false;					
					Navigator.loadProfile();
					break;
				};
				case 'isActiveDevice': {
					if (json.content) {
						User.device = json.content;
						var login = FileSys.readFromFile(Config.login_file);
						if (login != undefined && login.length) {
							User.login = login;
							User.CheckUser();
						}
					} else return;
					break;
				};
				case 'progressSubscription': {
					var check = json.content.check;
					json.content = json.content.modal;
					login = rc4_encode(Navigator.getInputsValues('.blue_block.reg input'));
					Navigator.parseConfig(json);
					if (Config.paymentInterval) {
						clearInterval(Config.paymentInterval);
						Config.paymentCount = 0;
					}					
					var func = 'Navigator.startCheckPayment('+check+',"'+login+'")';
					Config.paymentInterval = setInterval(func, Config.payment_delay);
					break;
				};
				case 'startCheckPayment': {
					if (json.error || json.content == undefined || !json.content) return;
					if (json.content) {
						if (User.login != params[1]) {
							User.login = params[1];
							User.is_login = true;
							FileSys.writeToFile(Config.login_file, User.login);
						}
						Navigator.closeModal('modal', 'payment');
						Navigator.parseConfig(json);
					} else return;
					break;
				};
				case 'loadLicense': {
					if (json.content) {
						Navigator.closeModal('modal');
						Navigator.parseConfig(json);
					}
					break;
				};
				case 'startSubscription':
				case 'loadSubscriptionVariants':				
				case 'loadBankCardInfo':
				case 'loadCouponForm':
				case 'startAuth': {
					Navigator.addHistory(url, 'center_0');					
					Navigator.parseConfig(json);
					break;
				};
				case 'loadProfile': {
					Navigator.addHistory(url, 'center_0');
					Navigator.parseConfig(json);
					if (User.is_login) {
						Navigator.clearAuthHistory();
					} else {
						Navigator.clearProfileHistory();
					}					
					break;
				}
				case 'loadSubscription': {
					if (User.license_confirm) {
						Navigator.addHistory(url, 'center_0');					
						Navigator.parseConfig(json);
					} else Navigator.parseConfig(json);
					break;
				}
				case 'activeFreeSubscription':
				case 'finishCoupon':			
				case 'loadReturn': {
					Navigator.parseConfig(json);
					break;
				};
				case 'loadHistory': {
					Navigator.current = params.element;
					Navigator.parseConfig(json);
					break;
				};
				default: {
					return;
				}
			}
		},
		error: function(jqxhr, textStatus, error){
			toggleLoadState();
			addLog(textStatus + ' : ' + error);
			if (!withoutErrorHandle) Navigator.errorHandle('Превышен интервал ожидания. Повторите попытку позже.', 'error');
		}
	});
};

Navigator.clearProfileHistory = function() {
	if (!Navigator.path.history.length) return;
	var newHistory = [];
	jQuery.each(Navigator.path.history, function(key, value) {		
		var url = value.url;
		if (url.indexOf('startSubscription', 0) < 0 && url.indexOf('loadSubscription', 0) < 0 &&
		    url.indexOf('loadCouponForm', 0) && url.indexOf('loadBankCardInfo', 0) < 0 &&
		    url.indexOf('LoadProfile', 0) < 0) {			
			newHistory.push(value);
		};
	});
	Navigator.path.history = newHistory;
};

Navigator.clearAuthHistory = function() {
	if (!Navigator.path.history.length) return;
	var newHistory = [];
	jQuery.each(Navigator.path.history, function(key, value) {		
		var url = value.url;
		if (url.indexOf('StartAuth', 0) < 0 && url.indexOf('LoadAuth', 0) < 0) {			
			newHistory.push(value);
		}; 
	});
	Navigator.path.history = newHistory;	
};


Navigator.errorHandle = function(error, callback) {
	if (!error.length) error = 'Произошла ошибка. Попробуйте позднее.';
	if (callback == undefined) callback = 'error';
	jQuery('.modal_window, #modalwrapper').remove();
	APP_STATE = STATE_MODAL;
	jQuery('#main').append('<div id="modalwrapper"></div><div class="modal_window" id="modal" style="height: 100px;"><p>'+error+'</p><span class="return button" id="modal_0" click="Navigator.closeModal(\'modal\',\''+callback+'\');">ОК</span></div>');
	Navigator.setForceFocus('modal_0');
};

Navigator.playPreview = function() {
	Player.url = Config.preview;
	APP_STATE = STATE_NORMAL;
	Player.playVideo();	
};

Navigator.clearStack = function() {
	Navigator['stack'] = [];
	jQuery('#stack').find('ul').html('');
	jQuery('.clear_playlist').hide();
};

Navigator.addStack = function(id, html) {
	if (Navigator.stack == undefined) {
		Navigator['stack'] = [];	
	}
	if (Navigator.stack.length == 7) return;
	Navigator.stack.push(id);
	jQuery('.clear_playlist').show();	
	jQuery('#stack').find('ul').append('<li type='+id+'>'+html+'</li>');
};

Navigator.callNext = function() {
	if (Navigator.stack == undefined) {
		Navigator.clearStack();
		return;
	}
	var id = Navigator.stack[0];
	if (id == undefined) {
		jQuery('.clear_playlist').hide();
		return;
	}
	if (Player.play) Player.stopVideo();
	Navigator.loadSongInfo(false, id, false, true);
	if (Navigator.stack.length == 0) jQuery('.clear_playlist').hide();
};

Navigator.addHistory = function(url, element) {	
	if (Navigator.path.current) {
		if (Navigator.path.current == url) return;		
		Navigator.path.history.push({'url': Navigator.path.current, 'element': false});
		if (Navigator.path.history[Navigator.path.history.length-1] != undefined) {
			Navigator.path.history[Navigator.path.history.length-1].element = element;
		}				
	} 	
	Navigator.path.current = url;
};

Navigator.callHistory = function() {
	Navigator.jsonp('loadHistory', false, true);
};

Navigator.getBlockElements = function(block) {
	var need_blocks;
	if (!block) {
		need_blocks = blocks;
	} else if (blocks[block] !== undefined) {
		need_blocks = {block : blocks[block]};
	} else return;
	jQuery.each(need_blocks, function(key, value) {
		if (value.elements) {
			var elements = value.elements[0].apply(Navigator, value.elements[1]);
			value.elements = elements[0];
			value.handle_nav = elements[1];
		}	
	});	
};

Navigator.setFocus = function(current, next, cur_block, next_block) {
	if (!jQuery('#'+next).length) return;
	if (blocks[next_block] && blocks[next_block].current_item !== undefined && cur_block != next_block) {
		next = blocks[next_block].current_item;
	}
	Config.focus = next;	
	jQuery('#'+current).removeClass('select');
	if (cur_block != next_block) {
		jQuery(blocks[cur_block].target_id).removeClass('select');
		jQuery(blocks[next_block].target_id).addClass('select');
	}
	jQuery('#'+next).addClass('select');
};

Navigator.setForceFocus = function(elem) {
	if (!jQuery('#'+elem).length) return false;
	var elem_arr = elem.split('_');
	/*if (blocks[elem_arr[0]] && blocks[elem_arr[0]].current_item !== undefined) {
		elem_arr = blocks[elem_arr[0]].current_item.split('_');
		elem = blocks[elem_arr[0]].current_item;
	}*/
	jQuery('#'+Config.focus).removeClass('select');	
	Config.focus = elem;
	jQuery('#'+elem).addClass('select');
	jQuery('#'+elem_arr[0]).addClass('select');
};

Navigator.loadGenre = function(params) {
	var id = jQuery('#'+params[0]+'_'+params[1]).attr('param');
	if (!id) return;
	var url = Config.server + 'catalog/loadGenre?jsoncallback=?&id='+id+'&country=' + User.params.country+'&localization='+Config.localization;	
	Navigator.addHistory(url, params[0]+'_'+params[1]);
	$.getJSON(url,
		function(json) {
			if (json.error) return Navigator.errorHandle(json.error);
			Navigator.parseConfig(json, params[0]);			
		}
	);
};

Navigator.activeFreeSubscription = function() {
	Navigator.jsonp('activeFreeSubscription', false, true);
};

Navigator.finishCoupon = function() {
	Navigator.jsonp('finishCoupon', false, true);
};

Navigator.loadCouponForm = function() {
	Navigator.jsonp('loadCouponForm', false, true);
};

Navigator.startCheckPayment = function(check, login) {
	Navigator.jsonp('startCheckPayment', [check, login], false, true);
};

Navigator.progressSubscription = function(id) {
	Navigator.jsonp('progressSubscription', id, true);
};

Navigator.startSubscription = function(id) {
	Navigator.jsonp('startSubscription', id, true);
};

Navigator.loadBankCardInfo = function(id) {
	Navigator.jsonp('loadBankCardInfo', id, true);
};

Navigator.loadSubscriptionVariants = function(id) {
	Navigator.jsonp('loadSubscriptionVariants', id, true);
};

Navigator.loadSubscription = function() {
	Navigator.jsonp('loadSubscription', false, true);
};

Navigator.loadLicense = function(page) {
	Navigator.jsonp('loadLicense', page, false, true);
};

Navigator.loadSupport = function() {
};

Navigator.loadProfile = function() {
	blocks['left'].current_item = 'left_3';
	Navigator.jsonp('loadProfile', false, true);
};

Navigator.logout = function() {
	Navigator.jsonp('logout', false, true);
};

Navigator.getInputsValues = function(selector) {
	var inputs = jQuery(selector);
	var result = '';
	var b = false;
	var tmp;
	jQuery.each(inputs, function(key, value) {		
		tmp = $(value).attr('value');
		if (tmp.length == 0) b = true;
		result = result + $(value).attr('value');
	});
	if (result.length && !b) return result;
	return false;
};

Navigator.startAuth = function() {
	var login = Navigator.getInputsValues('.blue_block.reg input');	
	if (login) Navigator.jsonp('startAuth', login, true);
	return false;
};

Navigator.finishAuth = function() {
	var password = Navigator.getInputsValues('.blue_block.reg input');
	if (password) Navigator.jsonp('finishAuth', password, true);
	return false;
};

Navigator.loadMain = function(params) {
	Navigator.jsonp('loadMain', params, true);
};

Navigator.loadSongInfo = function(element, id, quality_change, from_queue) {
	addLog(APP_STATE);
	if (APP_STATE == STATE_DISCONNECTED) return;
	var selector = '#'+element[0] + '_' + element[1];
	var elem = jQuery(selector);
	if (id == undefined) id = jQuery(elem).attr('param');
	if (quality_change == undefined) quality_change = false;
	if (!id) return;
	if (Player.play && !from_queue) {
		var html = jQuery(selector + ' .song_info').html();
		Navigator.addStack(id, html);
		return;
	}
	var url = Config.server + 'catalog/loadSongInfo?jsoncallback=?&id='+id+'&country=' + User.params.country + '&login=' + User.login + '&device=' + User.device + '&quality=' + Player.quality + '&quality_change=' + quality_change+'&localization='+Config.localization;
	addLog(url);
	$.ajax({
		url: url,
		dataType: 'json',
		timeout: Config.ajax_timeout, 
		success: function(json) {
			if (Player.play && !from_queue) {
				var html = jQuery(selector + ' .song_info').html();
				Navigator.addStack(id, html);
				return;
			}
			if (json.error) return Navigator.errorHandle(json.error);
			if (json.content == undefined) return;
			json = json.content;
			if (from_queue) {
				jQuery('#stack li:lt(1)').remove();
				Navigator.stack.splice(0, 1);
			}
			if (json.modal) {
				Navigator.parseConfig({'content': json.modal});
				Player.object_for_play = {'demo': json.is_demo, 'url': json.url, 'id': json.id};
				return;
			} else if (json.is_demo) {
				Player.object_for_play = {'demo': json.is_demo, 'url': json.url, 'id': json.id};
				Player.id = json.id;
				Player.playObject();
			} else {			
				if (json.url !== undefined && json.id !== undefined) {
					Player.object_for_play = false;
					Player.id = json.id;
					Player.playVideoUrl(json.url);
				} else return;
			}	
		},
		error: function(jqxhr, textStatus, error){			
			addLog(textStatus + ' : ' + error);			
		}
	});
};

Navigator.closeModal = function(id, callback) {
	jQuery('#'+id+', #modalwrapper').remove();
	APP_STATE = STATE_NORMAL;
	if (blocks[id] !== undefined) Navigator.setForceFocus(blocks[id].focus);
	blocks[id] = {};
	if (callback && callback !== undefined) {
		switch (callback) {
			case 'play': {
				if (Player.videoPlugin && Player.play) {
					Player.stopVideo();
				}
				Player.playObject();
				Navigator.setForceFocus('center_0');
				return;
			}
			case 'error': {
				Navigator.setForceFocus('center_0');
				return;
			}
			case 'payment': {
				if (Config.paymentInterval) {
					clearInterval(Config.paymentInterval);
					Config.paymentCount = 0;
				}
				return;
			}
			case 'preview': {
				if (Player.videoPlugin && Player.play) {
					Player.stopVideo();
				}
				Navigator.setForceFocus('center_0');
				Navigator.playPreview();
			}
			default: return;
		}
	}
};

Navigator.loadSongsByAuthor = function(params) {
	Navigator.jsonp('loadSongAuthor', params, true);
};

Navigator.parseConfig = function(json, source_block) {
	if (!json.content) return;
	jQuery.each(json.content, function(k,v) {	
		var block = {};	
		var func;
		if (v.params == undefined) return;
		jQuery.each(v.params, function(param, value) {				
			if (is_array(value)) {
				block[param] = [];
				jQuery.each(value, function(key, target) {	
					if (jQuery.isPlainObject(target)) {							
						if (target['func'] !== undefined) {
							switch (target['func']) {
								case 'Navigator.setFocus': func = Navigator.setFocus; break;
								case 'Navigator.loadGenre': func = Navigator.loadGenre; break;
								case 'Navigator.loadMain': func = Navigator.loadMain; break;
								case 'Navigator.loadSongsByAuthor': func = Navigator.loadSongsByAuthor; break;
								case 'Navigator.loadSongInfo': func = Navigator.loadSongInfo; break;
								default: func = Navigator.setFocus; break;
							};
							block[param].push([func, target['element']]);
						} else if (target['block'] !== undefined) {
							block[param].push([target['block'], target['element']]);
						} 
					} else {
						block[param].push(target);
					}
				});
			} else {
				if (param == 'elements' && value.func !== undefined) {
					block[param] = [];
					switch (value.func) {
						case 'Navigator.getElements': func = Navigator.getElements; break;
						default: func = Navigator.getElements; break;
					};
					block[param].push(func);
					block[param].push([value.selector]);
				} else {
					block[param] = value;
				}
			}
		});
		if (v.content !== undefined && v.target_id !== undefined) {
			block['target_id'] = v.target_id;
			blocks[v.target_block] = block;
			if (v.modal !== undefined) {
				jQuery('.modal_window, #modalwrapper').remove();
				jQuery(v.target_id).append(v.content);
				blocks[v.target_block]['focus'] = Config.focus;
				if (v.force_focus) {
					Navigator.setForceFocus(v.force_focus);
				} else Navigator.setForceFocus('modal_0');
				APP_STATE = STATE_MODAL;
			} else {				
				jQuery(v.target_id).html(v.content);
				Navigator.setForceFocus(Navigator.current);
			}	
			if (blocks[v.target_block].elements) Navigator.getBlockElements(v.target_block);
		} 
	});	
};

Navigator.callClickHandler = function(params) {
	var element = jQuery('#'+params[0]+'_'+params[1]);
	if (!element.length) return;
	var action_params = jQuery(element).attr('params');
	var action = blocks[params[0]].action;
	if (!action) return;
	action.apply(Navigator, [action_params]);	
};

Navigator.getElements = function(selector) {
	var elements = jQuery(selector);
	var elem = [];
	var elem_handle_nav = {};
	jQuery.each(elements, function(k,v) {
			if (jQuery(v).attr('id')) elem.push(jQuery(v).attr('id'));
			if (jQuery(v).attr('handle_nav')) {
				var json = jQuery.parseJSON(jQuery(v).attr('handle_nav'));
				elem_handle_nav[jQuery(v).attr('id')] = json;
			}
		}
	);
	return [elem, elem_handle_nav];
};

Navigator.getElementPosition = function(elements, position, current) {
	if (!elements) return undefined;
	current = parseInt(current);
	switch (position) {
		case 'previos':	return elements[current-1];
		case 'next':    return elements[current+1];
		case 'first':   return elements[0];
		case 'last':    return elements[elements.length-1];
		default:        return position;
	}
};

Navigator.callHandler = function(func, params) {
	var current = params[0]+'_'+params[1];
	if (blocks[params[0]] && blocks[params[0]][func] !== undefined) {
		if (blocks[params[0]].current_item !== undefined && func == 'click') blocks[params[0]].current_item = current;
		if (blocks[params[0]].handle_nav && blocks[params[0]].handle_nav[current] && blocks[params[0]].handle_nav[current][func] !== undefined) {
			var next = blocks[params[0]].handle_nav[current][func];			
			if (!next) return;
			var next_arr = next.split('_');
			Navigator.setFocus(current, next, params[0], next_arr[0]);
			return false;
		}		
		if (is_array(blocks[params[0]][func])) {
			jQuery.each(blocks[params[0]][func], function(k,v) {
					if (is_array(v)) {
						if (jQuery.isFunction(v[0])) {
							if (func == 'click') {
								params = (params + ',' + v[1]).split(',');	
								v[0].apply(this, [params]);
							} else {
								var next = Navigator.getElementPosition(blocks[params[0]].elements, v[1], params[1]);
								if (!next) return;
								v[0].apply(this, [current, next, params[0], params[0]]);
							}
							return false;
						} else if (blocks[v[0]] !== undefined) {							
							var next = Navigator.getElementPosition(blocks[v[0]].elements, v[1]);													
							if (!next) return;							
							Navigator.setFocus(current, next, params[0], v[0]);
							return false;
						}
					} else if (blocks[v] != undefined) {
						var next = blocks[v].class_name;
						Navigator.setFocus(null, next, params[0], v);
						return false;
					} else if (blocks[v]) {
						var next = blocks[v].class_name+'_0';
						Navigator.setFocus(current, next, params[0], v);
						return false;
					}
				}
			);
		} 
	} 
};

Navigator.callReturn = function(handle_url) {
	var url = Navigator.path.current;
	if ((url == undefined || !url.length) && handle_url != undefined) {
		switch (handle_url) {
			case 'profile': {
				Navigator.loadProfile();				
				break;
			}				
		}
	} else {
		Navigator.jsonp('loadReturn', url, true);
	}
	Navigator.loadSongInfo(false, Player.object_for_play.id, false);
};

var blocks = {
	'left': {
		'current_item': 'left_0',
		'up':	[[Navigator.setFocus, 'previos'], ['left', 'last']],
		'down':	[[Navigator.setFocus, 'next'], ['left', 'first']],
		'left': false,		
		'right': [['center', 'first'], 'upcenter'],
		'click': [[Navigator.loadMain, 'center']],
		'elements': [Navigator.getElements, ['.left li']],
		'class_name': 'left'
	}
};