var Player = {	
	'videoPlugin': null,
	'videoHandle': null,
	'audioPlugin': null,
	'play': false,
	'quality': QUALITY_MEDIUM,
	'url': '',
	'min': {'width': 609, 'height': 346, 'left': 656, 'top': 88, 'display': 'block'/*, 'border': '1px solid red'*/},
	'max': {'width': 1280, 'height': 675, 'left': 0, 'top': 0, 'display': 'block'/*, 'border': '1px solid red'*/},
	'hide': {'display': 'none'},
	'current': false,
	'object_for_play': false,
	'is_mute': false
};

Player.init = function() {
	if (!this.videoPlugin) this.videoPlugin = document.getElementById('pluginPlayer');
	if (!this.videoHandle) this.videoHandle = jQuery('#pluginPlayer');
	if (!this.audioPlugin) {
		this.audioPlugin = document.getElementById('audioPlayer');
		if (this.audioPlugin.GetExternalOutMode()<0) {
			this.audioPlugin.SetSystemMute(1);
			this.audioPlugin.SetUserMute(1);
			return;
		}
		if (this.audioPlugin.GetSystemMute() || this.audioPlugin.GetUserMute()) Player.is_mute = true;		
		this.audioPlugin.SetSystemMute(0);
		this.audioPlugin.SetUserMute(0);
	}
	if (APP_STATE == STATE_FULLSCREEN) {
		Player.setFullscreen();		
	} else {
		Player.setWindow();
	}
	this.videoPlugin.OnBufferingStart = 'Player.onBufferingStart';
    this.videoPlugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.videoPlugin.OnBufferingComplete = 'Player.onBufferingComplete';
	this.videoPlugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.videoPlugin.OnStreamInfoReady = 'Player.setTotalTime';
	this.videoPlugin.OnConnectionFailed = 'Player.OnConnectionFailed';
	this.videoPlugin.OnAuthenticationFailed = 'Player.OnAuthenticationFailed';
	this.videoPlugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
};

Player.OnConnectionFailed = function() {
	addLog('OnConnectionFailed');
	Player.stopVideo();
};

Player.OnAuthenticationFailed = function() {
	addLog('OnAuthenticationFailed');
	Player.stopVideo();
};

Player.OnNetworkDisconnected = function() {
	addLog('OnNetworkDisconnected');
	Player.stopVideo();
};

Player.setCurTime = function(time) {
	var	sec = Math.floor(parseInt(time) / 1000);
	var mins = (sec % 3600 < 600 ? '0' : '') + Math.floor(sec % 3600 / 60);
	var secs = (sec % 60 < 10 ? '0' : '') + sec % 60;
	$('#minutes').html(mins);
	$('#seconds').html(secs);
	if (Player.object_for_play && Player.object_for_play.demo) {
		if (parseInt(time) >= Player.object_for_play.demo * 1000) {			
			APP_STATE = STATE_NORMAL;
			jQuery('.full_screen').html('Во весь экран');
			Player.stopVideo();		
			Navigator.callNext();
		}
	}
	if (Player.videoPlugin.GetDuration() == time) {
		Player.stopVideo();
		var element = jQuery('.full_screen');
		element.html(element.attr('max'));
		Navigator.callNext();
	}
};

Player.setTotalTime = function() {
	var sec;
	if (Player.object_for_play && Player.object_for_play.demo) {
		sec = Player.object_for_play.demo;
	} else {
		sec = Math.floor(parseInt(Player.videoPlugin.GetDuration()) / 1000);
	}
	var mins = (sec % 3600 < 600 ? '0' : '') + Math.floor(sec % 3600 / 60);
	var secs = (sec % 60 < 10 ? '0' : '') + sec % 60;
	$('#current_time').html(mins+':'+secs);
};

Player.onBufferingStart = function () {
    alert("Buffering start...");
};

Player.onBufferingProgress = function (percent) {
    alert("Buffering:" + percent + "%");
};

Player.onBufferingComplete = function () {
    alert("Buffering complete...");
};

Player.setWindow = function() {
	APP_STATE = STATE_NORMAL;
	this.videoHandle.css(Player.min);
	this.videoPlugin.SetDisplayArea(492, 66, 461, 265);
};

Player.setFullscreen = function() {
	APP_STATE = STATE_FULLSCREEN;
	this.videoHandle.css(Player.max);
	this.videoPlugin.SetDisplayArea(30, 0, 900, 520);
};

Player.playVideo = function() {
	if (APP_STATE == STATE_DISCONNECTED) return;
	Player.init();
	this.videoPlugin.InitPlayer(Player.url);
	this.videoPlugin.StartPlayback();
	var element = jQuery('.full_screen');
	if (APP_STATE == STATE_FULLSCREEN) {
		Player.setFullscreen();	
		element.html(element.attr('min'));		
	} else {
		Player.setWindow();
		element.html(element.attr('max'));
	}
	if (Player.quality == QUALITY_MEDIUM || Player.quality == QUALITY_HIGH) {
		element.show();
	}
	this.play = true;
};

Player.playVideoUrl = function(url) {		
	this.url = url;
	this.playVideo();
};

Player.stopVideo = function() {
	APP_STATE = STATE_NORMAL;
	if (this.videoPlugin && this.play) {
		this.videoPlugin.Stop();
		this.videoHandle.css(Player.hide);		
	}
	$('#minutes, #seconds').html('00');
	$('#current_time').html('00:00');
	this.play = false;
	Player.current = false;
	Player.object_for_play = false;
	jQuery('.high_quality').show();
	jQuery('.full_screen').hide();
};

Player.playObject = function() {
	if (Player.object_for_play) {
		Player.playVideoUrl(Player.object_for_play.url);
		Player.id = Player.object_for_play.id;
	}
};