var TVKey = {};
var NumberKeys = {'17':0, '101':1, '98':2, '6':3, '8':4, '9':5, '10':6, '12':7, '13':8, '14':9};

TVKey.input = function(key) {
	if (!key) return;
	var number = NumberKeys[key];
	var element = $('#'+Config.focus);
	if ($(element).get(0).tagName == 'INPUT') {
		$(element).attr('value', number);
		var focus = Config.focus.split('_');
		var next = focus[0]+'_'+(parseInt(focus[1])+1);
		Navigator.setFocus(Config.focus, next);
	}
	return;
};

TVKey.keyDown = function() {
	addLog(event.keyCode);
	var is_valid_key;
	var keyCode = event.keyCode;
	if (STATE_LOAD == STATE_LOADING) {
		is_valid_key = Config.app_states[STATE_LOADING].indexOf(keyCode);
	} else is_valid_key = Config.app_states[APP_STATE].indexOf(keyCode);
	if (is_valid_key == -1) return;
	var focus = Config.focus.split('_');
	var block = focus[0];
	var element = focus[1];
	var params = [block, element];
	switch(keyCode) {
		case tvKey.KEY_0: 
		case tvKey.KEY_1: 
		case tvKey.KEY_2: 
		case tvKey.KEY_3: 
		case tvKey.KEY_4: 
		case tvKey.KEY_5: 
		case tvKey.KEY_6: 
		case tvKey.KEY_7: 
		case tvKey.KEY_8: 
		case tvKey.KEY_9: 
			TVKey.input(keyCode);
			break;
		case tvKey.KEY_PANEL_CH_UP:
		case tvKey.KEY_UP:
			Navigator.callHandler('up', params);
			break;
		case tvKey.KEY_PANEL_CH_DOWN:
		case tvKey.KEY_DOWN:
			Navigator.callHandler('down', params);
			break;
		case 37:
		case tvKey.KEY_PANEL_VOL_DOWN:
		case tvKey.KEY_LEFT:
			Navigator.callHandler('left', params);
			break;
		case 39:
		case tvKey.KEY_PANEL_VOL_UP:
		case tvKey.KEY_RIGHT:
			Navigator.callHandler('right', params);
			break;
		case tvKey.KEY_PANEL_ENTER:	
		case tvKey.KEY_PANEL_SOURCE:
		case tvKey.KEY_ENTER:
			if (block == 'alphabet' || block == 'pagination') {
				Navigator.current = Config.focus;		
			} else Navigator.current = 'center_0';	
			var click = $('#'+Config.focus).attr('click');
			if (click != undefined) {
				eval(click);
				break;
			}
			Navigator.callHandler('click', params);
			break;
		case tvKey.KEY_STOP:
			Player.stopVideo();
			APP_STATE = STATE_NORMAL;
			var element = jQuery('.full_screen');
			element.html(element.attr('max'));
			if (Navigator.stack && Navigator.stack.length == 0) jQuery('.clear_playlist').hide();
			break;
		case tvKey.KEY_PANEL_MENU:
		case tvKey.KEY_RETURN:
			//showLog();
			widgetAPI.blockNavigation(event);
			if (APP_STATE == STATE_MODAL) {
				addLog("APP_STATE == STATE_MODAL");
				var close_button = $('#modal span.return.button');
				var click = close_button.attr('click');
				if (click) {
					eval(click);
				} else {
					Navigator.closeModal('modal');
				}
				break;
			} 
			if (APP_STATE == STATE_FULLSCREEN) {
				addLog("APP_STATE == STATE_FULLSCREEN");
				var element = jQuery('.full_screen');
				element.html(element.attr('max'));
				Player.setWindow();
				break;
			}
			if (STATE_LOAD == STATE_LOADING) {
				addLog("STATE_LOAD == STATE_LOADING");
				if (!Config.is_unbreakable) toggleLoadState();
				break;
			}
			if (!Navigator.path.history.length) {
				addLog("!Navigator.path.history.length");
				Player.stopVideo();
				if (Player.is_mute) {
					Player.audioPlugin.SetSystemMute(1);
					Player.audioPlugin.SetUserMute(1);
				}
				widgetAPI.sendReturnEvent();
			} else { 
				addLog("ELSE"); 
				Navigator.callHistory();				
			}
			break;
		case tvKey.KEY_FF:
			Navigator.callNext();
			break;
		case tvKey.KEY_BLUE:
			var text_element = jQuery('.high_quality');
			if (text_element.css('display') == 'none') return;
			var fullscreen_element = jQuery('.full_screen');
			if (Player.quality == QUALITY_HIGH) {
				text_element.html(text_element.attr('low'));
				fullscreen_element.hide();
				Player.quality = QUALITY_LOW;
				APP_STATE = STATE_NORMAL;
			} else if (Player.quality == QUALITY_MEDIUM) {
				text_element.html(text_element.attr('high'));				
				Player.quality = QUALITY_HIGH;
			} else {
				text_element.html(text_element.attr('medium'));
				Player.quality = QUALITY_MEDIUM;
			}
			if (Player.videoPlugin && Player.play) {			
				Player.stopVideo();				
				Navigator.loadSongInfo(false, Player.id, true);				
			}			
			break;
		/*case tvKey.KEY_MUTE:
			break;
		case tvKey.KEY_VOL_UP:
			if (Player.audioPlugin == undefined) return;
			Player.audioPlugin.SetVolumeWithKey(0);
			break;
		case tvKey.KEY_VOL_DOWN:
			if (Player.audioPlugin == undefined) return;
			Player.audioPlugin.SetVolumeWithKey(1);
			break;*/	
		case tvKey.KEY_GREEN:
			if (Player.quality == QUALITY_LOW) {
				return;
			}
			if (Player.videoPlugin && Player.play) {
				var element = jQuery('.full_screen');
				if (APP_STATE == STATE_FULLSCREEN) {
					APP_STATE = STATE_NORMAL;
					element.html(element.attr('max'));
					Player.setWindow();
				} else {				
					APP_STATE = STATE_FULLSCREEN;
					element.html(element.attr('min'));
					Player.setFullscreen();
				}
			}
			break;
		case tvKey.KEY_RED:
			Navigator.clearStack();
			break;
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			Player.stopVideo();
			if (Player.is_mute) {
				Player.audioPlugin.SetSystemMute(1);
				Player.audioPlugin.SetUserMute(1);
			}	
			widgetAPI.sendExitEvent();
			break;
		case tvKey.KEY_YELLOW:
			//showLog();
			break;
		default: return;
	}
	
};
